﻿using System.ComponentModel;
using System.Drawing;

using DevExpress.Utils.Serializing;

namespace CustomControls.Pattern
{
    /// <summary>
    /// 文本设置
    /// </summary>
    [TypeConverter(typeof(CodeOptionsTypeConverter))]
    public class CodeOptions
    {
        [DisplayName("Font Family")]
        [Description("Font Family description")]
        [Category("Data")]
        [DefaultValue(FontFamily.Arial)]
        [XtraSerializableProperty]
        public FontFamily FontFamily { get; set; } = FontFamily.Arial;

        [DisplayName("Font Size")]
        [Description("Font Size description")]
        [Category("Data")]
        [DefaultValue(10)]
        [XtraSerializableProperty]
        public int FontSize { get; set; } = 10;

        [DisplayName("Font Style")]
        [Description("Font Style description")]
        [Category("Data")]
        [DefaultValue(FontStyle.Regular)]
        [XtraSerializableProperty]
        public FontStyle FontStyle { get; set; } = FontStyle.Regular;

        /// <summary>
        /// 设置文本属性
        /// </summary>
        public void Assign(CodeOptions options)
        {
            FontFamily = options.FontFamily;
            FontSize = options.FontSize;
            FontStyle = options.FontStyle;
        }
    }
}